Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2643)
@@ -27,6 +27,4 @@
    USE sbc_oce , ONLY :  atm_co2
 #endif
-   USE lib_mpp
-   USE lib_fortran
 
    IMPLICIT NONE
@@ -35,7 +33,9 @@
    PUBLIC   p4z_flx  
    PUBLIC   p4z_flx_init  
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  oce_co2            !: ocean carbon flux 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  satmco2            !: atmospheric pco2
+   PUBLIC   p4z_flx_alloc  
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: oce_co2   !: ocean carbon flux 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: satmco2   !: atmospheric pco2 
+
    REAL(wp)                             ::  t_oce_co2_flx      !: Total ocean carbon flux 
    REAL(wp)                             ::  t_atm_co2_flx      !: global mean of atmospheric pco2
@@ -63,4 +63,9 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zkgco2 => wrk_2d_1, zkgo2 => wrk_2d_2, zh2co3 => wrk_2d_3 
+      USE wrk_nemo, ONLY: zoflx  => wrk_2d_4, zkg   => wrk_2d_5
+      USE wrk_nemo, ONLY: zdpco2 => wrk_2d_6, zdpo2 => wrk_2d_7
+      !
       INTEGER, INTENT(in) :: kt
       INTEGER  ::   ji, jj, jrorr
@@ -68,11 +73,11 @@
       REAL(wp) ::   zfld, zflu, zfld16, zflu16, zfact
       REAL(wp) ::   zph, zah2, zbot, zdic, zalk, zsch_o2, zalka, zsch_co2
-      REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3
-#if defined key_diatrc && defined key_iomput
-      REAL(wp), DIMENSION(jpi,jpj) ::  zoflx, zkg, zdpco2, zdpo2
-#endif
       CHARACTER (len=25) :: charout
 
       !!---------------------------------------------------------------------
+
+      IF( wrk_in_use(2, 1,2,3,4,5,6,7) ) THEN
+         CALL ctl_stop('p4z_flx: requested workspace arrays unavailable') ; RETURN
+      END IF
 
       ! SURFACE CHEMISTRY (PCO2 AND [H+] IN
@@ -149,6 +154,5 @@
             zfld = satmco2(ji,jj) * tmask(ji,jj,1) * chemc(ji,jj,1) * zkgco2(ji,jj)
             zflu = zh2co3(ji,jj) * tmask(ji,jj,1) * zkgco2(ji,jj)
-            oce_co2(ji,jj) = ( zfld - zflu ) * rfact &
-               &             * e1t(ji,jj) * e2t(ji,jj) * tmask(ji,jj,1) * 1000.
+            oce_co2(ji,jj) = ( zfld - zflu ) * rfact * e1e2t(ji,jj) * tmask(ji,jj,1) * 1000.
             ! compute the trend
             tra(ji,jj,1,jpdic) = tra(ji,jj,1,jpdic) + ( zfld - zflu ) / fse3t(ji,jj,1)
@@ -162,5 +166,5 @@
             ! Save diagnostics
 #  if ! defined key_iomput
-            zfact = 1. / ( e1t(ji,jj) * e2t(ji,jj) ) / rfact
+            zfact = 1. / e1e2t(ji,jj) / rfact
             trc2d(ji,jj,jp_pcs0_2d    ) = oce_co2(ji,jj) * zfact
             trc2d(ji,jj,jp_pcs0_2d + 1) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
@@ -180,5 +184,5 @@
       t_oce_co2_flx = t_oce_co2_flx + glob_sum( oce_co2(:,:) )                     ! Cumulative Total Flux of Carbon
       IF( kt == nitend ) THEN
-         t_atm_co2_flx = glob_sum( satmco2(:,:) * e1t(:,:) * e2t(:,:) )            ! Total atmospheric pCO2
+         t_atm_co2_flx = glob_sum( satmco2(:,:) * e1e2t(:,:) )            ! Total atmospheric pCO2
          !
          t_oce_co2_flx = (-1.) * t_oce_co2_flx  * 12. / 1.e15                      ! Conversion in PgC ; negative for out of the ocean
@@ -203,5 +207,5 @@
 
 # if defined key_diatrc && defined key_iomput
-      CALL iom_put( "Cflx" , oce_co2(:,:) / ( e1t(:,:) * e2t(:,:) ) / rfact  )
+      CALL iom_put( "Cflx" , oce_co2(:,:) /  e1e2t(:,:) / rfact  
       CALL iom_put( "Oflx" , zoflx  )
       CALL iom_put( "Kg"   , zkg    )
@@ -210,4 +214,6 @@
 #endif
 
+      IF( wrk_not_released(2, 1,2,3,4,5,6,7) ) CALL ctl_stop('p4z_flx: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_flx
 
@@ -238,5 +244,5 @@
 
       ! interior global domain surface
-      area = glob_sum( e1t(:,:) * e2t(:,:) )  
+      area = glob_sum( e1e2t(:,:) )  
 
       ! Initialization of Flux of Carbon
@@ -249,4 +255,15 @@
    END SUBROUTINE p4z_flx_init
 
+   INTEGER FUNCTION p4z_flx_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_flx_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( oce_co2(jpi,jpj), satmco2(jpi,jpj), STAT=p4z_flx_alloc )
+
+      IF( p4z_flx_alloc /= 0 ) CALL ctl_warn('p4z_flx_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_flx_alloc
+
 #else
    !!======================================================================
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2643)
@@ -21,12 +21,11 @@
 
    PUBLIC   p4z_int  
+   PUBLIC   p4z_int_alloc
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      tgfunc,            &  !:  Temp. dependancy of various biological rates
-      tgfunc2               !:  Temp. dependancy of mesozooplankton rates 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tgfunc  !: Temp. dependancy of various biological rates
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tgfunc2 !: Temp. dependancy of mesozooplankton rates
 
    !! * Module variables
-   REAL(wp) :: &
-      xksilim = 16.5E-6        ! Half-saturation constant for the computation of the Si half-saturation constant
+   REAL(wp) :: xksilim = 16.5E-6   ! Half-saturation constant for the computation of the Si half-saturation constant
 
 
@@ -76,4 +75,15 @@
    END SUBROUTINE p4z_int
 
+   INTEGER FUNCTION p4z_int_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_int_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( tgfunc(jpi,jpj,jpk), tgfunc2(jpi,jpj,jpk), STAT=p4z_int_alloc )
+
+      IF( p4z_int_alloc /= 0 ) CALL ctl_warn('p4z_int_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_int_alloc
+
 #else
    !!======================================================================
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2643)
@@ -31,14 +31,11 @@
 
    !! * Shared module variables
-   REAL(wp), PUBLIC ::   &
-     kdca = 0.327e3_wp   ,  &  !:
-     nca  = 1.0_wp             !:
+   REAL(wp), PUBLIC :: kdca = 0.327e3_wp  !: diss. rate constant calcite
+   REAL(wp), PUBLIC :: nca  = 1.0_wp      !: order of reaction for calcite dissolution
 
    !! * Module variables
-   REAL(wp) :: &
-      calcon = 1.03E-2        ! mean calcite concentration [Ca2+] in sea water [mole/kg solution]
-
-   INTEGER ::               &
-     rmtss                    !: number of seconds per month
+   REAL(wp) :: calcon = 1.03E-2           !: mean calcite concentration [Ca2+] in sea water [mole/kg solution]
+ 
+   INTEGER  :: rmtss                      !: number of seconds per month 
 
    !!----------------------------------------------------------------------
@@ -60,4 +57,7 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zco3 => wrk_3d_2, zcaldiss => wrk_3d_3 
+      !
       INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  ::   ji, jj, jk, jn
@@ -65,14 +65,15 @@
       REAL(wp) ::   zdispot, zfact, zalka
       REAL(wp) ::   zomegaca, zexcess, zexcess0
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zco3
 #if defined key_diatrc && defined key_iomput
       REAL(wp) ::   zrfact2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zcaldiss
 #endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
+      IF(  wrk_in_use(3, 2,3) ) THEN
+         CALL ctl_stop('p4z_lys: requested workspace arrays unavailable')  ;  RETURN
+      END IF
+
       zco3(:,:,:) = 0.
-
 # if defined key_diatrc && defined key_iomput
       zcaldiss(:,:,:) = 0.
@@ -186,4 +187,6 @@
        ENDIF
 
+      IF( wrk_not_released(3, 2,3) ) CALL ctl_stop('p4z_lys: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_lys
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2643)
@@ -6,5 +6,5 @@
    !! History :   1.0  !  2004     (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
-   !!             3.2  !  2009-04  (C. Ethe, G. Madec)  optimisaion
+   !!             3.2  !  2009-04  (C. Ethe, G. Madec)  optimisation
    !!----------------------------------------------------------------------
 #if defined  key_pisces
@@ -24,7 +24,8 @@
    PUBLIC   p4z_opt        ! called in p4zbio.F90 module
    PUBLIC   p4z_opt_init   ! called in trcsms_pisces.F90 module
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   etot, enano, ediat   !: PAR for phyto, nano and diat 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   emoy                 !: averaged PAR in the mixed layer
+   PUBLIC   p4z_opt_alloc
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: etot, enano, ediat   !: PAR for phyto, nano and diat 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: emoy                 !: averaged PAR in the mixed layer
 
    INTEGER  ::  nksrp   ! levels below which the light cannot penetrate ( depth larger than 391 m)
@@ -43,4 +44,5 @@
 CONTAINS
 
+
    SUBROUTINE p4z_opt( kt, jnt )
       !!---------------------------------------------------------------------
@@ -52,4 +54,10 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zdepmoy => wrk_2d_1, zetmp => wrk_2d_2
+      USE wrk_nemo, ONLY: zekg    => wrk_3d_2, zekr  => wrk_3d_3, zekb => wrk_3d_4
+      USE wrk_nemo, ONLY: ze0     => wrk_3d_5, ze1   => wrk_3d_6
+      USE wrk_nemo, ONLY: ze2     => wrk_3d_7, ze3   => wrk_3d_8
+      !
       INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
       INTEGER  ::   ji, jj, jk
@@ -57,9 +65,9 @@
       REAL(wp) ::   zchl, zxsi0r
       REAL(wp) ::   zc0 , zc1 , zc2, zc3
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zdepmoy, zetmp
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zekg, zekr, zekb
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze1 , ze2 , ze3, ze0
       !!---------------------------------------------------------------------
 
+      IF( ( wrk_in_use(2, 1,2) ) .OR. ( wrk_in_use(3, 2,3,4,5,6,7,8) ) ) THEN
+         CALL ctl_stop('p4z_opt: requested workspace arrays unavailable')  ;  RETURN
+      END IF
 
       !     Initialisation of variables used to compute PAR
@@ -223,4 +231,7 @@
 #endif
       !
+      IF( ( wrk_not_released(2, 1,2) ) .OR. ( wrk_not_released(3, 2,3,4,5,6,7,8) ) ) &
+        &         CALL ctl_stop('p4z_opt: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_opt
 
@@ -245,4 +256,17 @@
       ! 
    END SUBROUTINE p4z_opt_init
+
+   INTEGER FUNCTION p4z_opt_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_opt_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( etot (jpi,jpj,jpk), enano(jpi,jpj,jpk), &
+        &       ediat(jpi,jpj,jpk), emoy (jpi,jpj,jpk), STAT=p4z_opt_alloc )
+
+      IF( p4z_opt_alloc /= 0 ) CALL ctl_warn('p4z_opt_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_opt_alloc
+
 #else
    !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2643)
@@ -22,7 +22,4 @@
    USE iom
 
-   USE lib_mpp
-   USE lib_fortran
-
    IMPLICIT NONE
    PRIVATE
@@ -30,4 +27,5 @@
    PUBLIC   p4z_prod         ! called in p4zbio.F90
    PUBLIC   p4z_prod_init    ! called in trcsms_pisces.F90
+   PUBLIC   p4z_prod_alloc
 
    !! * Shared module variables
@@ -43,5 +41,5 @@
      grosip    = 0.151_wp
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk)  ::  prmax 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: prmax
    
    REAL(wp) ::   &
@@ -61,4 +59,5 @@
 CONTAINS
 
+
    SUBROUTINE p4z_prod( kt , jnt )
       !!---------------------------------------------------------------------
@@ -70,4 +69,13 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zmixnano    => wrk_2d_1 , zmixdiat     => wrk_2d_2, zstrn  => wrk_2d_3
+      USE wrk_nemo, ONLY: zpislopead  => wrk_3d_2 , zpislopead2  => wrk_3d_2
+      USE wrk_nemo, ONLY: zprdia      => wrk_3d_4 , zprbio       => wrk_3d_5, zysopt => wrk_3d_6
+      USE wrk_nemo, ONLY: zprorca     => wrk_3d_7 , zprorcad     => wrk_3d_8
+      USE wrk_nemo, ONLY: zprofed     => wrk_3d_9 , zprofen      => wrk_3d_10
+      USE wrk_nemo, ONLY: zprochln    => wrk_3d_11, zprochld     => wrk_3d_12
+      USE wrk_nemo, ONLY: zpronew     => wrk_3d_13, zpronewd     => wrk_3d_14
+      !
       INTEGER, INTENT(in) :: kt, jnt
       INTEGER  ::   ji, jj, jk
@@ -81,12 +89,10 @@
       REAL(wp) ::   zrfact2
 #endif
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zmixnano   , zmixdiat, zstrn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpislopead , zpislopead2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprdia     , zprbio, zysopt
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprorca    , zprorcad, zprofed
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprofen   , zprochln, zprochld
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpronew    , zpronewd
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
+
+      IF( ( wrk_in_use(2, 1,2,3) ) .OR. ( wrk_in_use(3, 2,3,4,5,6,7,8,9,10,11,12,13,14) ) ) THEN
+         CALL ctl_stop('p4z_prod: requested workspace arrays unavailable')  ;  RETURN
+      END IF
 
       zprorca (:,:,:) = 0.0
@@ -187,5 +193,4 @@
                   zsilfac = MIN( 6.4,zsilfac * zsilfac2)
                   zysopt(ji,jj,jk) = grosip * zlim1 * zsilfac
-
               ENDIF
             END DO
@@ -363,4 +368,7 @@
        ENDIF
 
+      IF( ( wrk_not_released(2, 1,2,3) ) .OR. ( wrk_not_released(3, 2,3,4,5,6,7,8,9,10,11,12,13,14) ) ) &
+        &         CALL ctl_stop('p4z_prod: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_prod
 
@@ -408,4 +416,14 @@
 
 
+   INTEGER FUNCTION p4z_prod_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_prod_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( prmax(jpi,jpj,jpk), STAT=p4z_prod_alloc )
+
+      IF( p4z_prod_alloc /= 0 ) CALL ctl_warn('p4z_prod_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_prod_alloc
 
 #else
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2643)
@@ -29,4 +29,5 @@
    PUBLIC   p4z_rem         ! called in p4zbio.F90
    PUBLIC   p4z_rem_init    ! called in trcsms_pisces.F90
+   PUBLIC   p4z_rem_alloc
 
    !! * Shared module variables
@@ -39,6 +40,5 @@
      oxymin  = 1.e-6_wp         !:
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::    & !:
-     &                   denitr                     !: denitrification array
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: denitr  !: denitrification array
 
 
@@ -53,4 +53,5 @@
 CONTAINS
 
+
    SUBROUTINE p4z_rem( kt )
       !!---------------------------------------------------------------------
@@ -61,4 +62,8 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: ztempbac => wrk_2d_1
+      USE wrk_nemo, ONLY: zdepbac  => wrk_3d_2, zfesatur => wrk_3d_2, zolimi => wrk_3d_4
+      !
       INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  ::   ji, jj, jk
@@ -72,10 +77,11 @@
 #endif
       REAL(wp) ::   zlamfac, zonitr, zstep
-      REAL(wp), DIMENSION(jpi,jpj)     ::   ztempbac
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepbac, zfesatur, zolimi
       CHARACTER (len=25) :: charout
 
       !!---------------------------------------------------------------------
 
+      IF( ( wrk_in_use(2, 1) ) .OR. ( wrk_in_use(3, 2,3,4) ) ) THEN
+         CALL ctl_stop('p4z_rem: requested workspace arrays unavailable')  ;  RETURN
+      END IF
 
        ! Initialisation of temprary arrys
@@ -393,4 +399,7 @@
        ENDIF
 
+      IF( ( wrk_not_released(2, 1) ) .OR. ( wrk_not_released(3, 2,3,4) ) )  &
+        &         CALL ctl_stop('p4z_rem: failed to release workspace arrays')
+
    END SUBROUTINE p4z_rem
 
@@ -431,4 +440,14 @@
    END SUBROUTINE p4z_rem_init
 
+   INTEGER FUNCTION p4z_rem_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_rem_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( denitr(jpi,jpj,jpk), STAT=p4z_rem_alloc )
+
+      IF( p4z_rem_alloc /= 0 ) CALL ctl_warn('p4z_rem_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_rem_alloc
 #else
    !!======================================================================
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2643)
@@ -18,6 +18,4 @@
    USE oce_trc         !
    USE sms_pisces
-   USE lib_mpp
-   USE lib_fortran
    USE prtctl_trc
    USE p4zbio
@@ -27,5 +25,4 @@
    USE p4zrem
    USE p4zlim
-   USE lbclnk
    USE iom
 
@@ -36,32 +33,34 @@
    PUBLIC   p4z_sed   
    PUBLIC   p4z_sed_init   
+   PUBLIC   p4z_sed_alloc
 
    !! * Shared module variables
-   LOGICAL, PUBLIC ::    &
-     ln_dustfer  = .FALSE.      ,  &  !:
-     ln_river    = .FALSE.      ,  &  !:
-     ln_ndepo    = .FALSE.      ,  &  !:
-     ln_sedinput = .FALSE.            !:
-
-   REAL(wp), PUBLIC ::   &
-     sedfeinput = 1.E-9_wp   ,  &  !:
-     dustsolub  = 0.014_wp         !:
+   LOGICAL, PUBLIC :: ln_dustfer  = .FALSE.    !: boolean for dust input from the atmosphere
+   LOGICAL, PUBLIC :: ln_river    = .FALSE.    !: boolean for river input of nutrients
+   LOGICAL, PUBLIC :: ln_ndepo    = .FALSE.    !: boolean for atmospheric deposition of N
+   LOGICAL, PUBLIC :: ln_sedinput = .FALSE.    !: boolean for Fe input from sediments
+
+   REAL(wp), PUBLIC :: sedfeinput = 1.E-9_wp   !: Coastal release of Iron
+   REAL(wp), PUBLIC :: dustsolub  = 0.014_wp   !: Solubility of the dust
 
    !! * Module variables
-   REAL(wp) :: ryyss               !: number of seconds per year 
-   REAL(wp) :: ryyss1              !: inverse of ryyss
-   REAL(wp) :: rmtss               !: number of seconds per month
-   REAL(wp) :: rday1               !: inverse of rday
-
-   INTEGER , PARAMETER :: &
-        jpmth = 12, jpyr = 1
-   INTEGER ::                   &
-      numdust,                  &  !: logical unit for surface fluxes data
-      nflx1 , nflx2,            &  !: first and second record used
-      nflx11, nflx12      ! ???
-   REAL(wp), DIMENSION(jpi,jpj,jpmth) ::  dustmo    !: set of dust fields
-   REAL(wp), DIMENSION(jpi,jpj)      ::  rivinp, cotdep, nitdep, dust 
-   REAL(wp), DIMENSION(jpi,jpj)      ::  e1e2t
-   REAL(wp), DIMENSION(jpi,jpj,jpk)  ::  ironsed 
+   REAL(wp) :: ryyss                  !: number of seconds per year 
+   REAL(wp) :: ryyss1                 !: inverse of ryyss
+   REAL(wp) :: rmtss                  !: number of seconds per month
+   REAL(wp) :: rday1                  !: inverse of rday
+
+   INTEGER , PARAMETER :: jpmth = 12  !: number of months per year
+   INTEGER , PARAMETER :: jpyr  = 1   !: one year
+
+   INTEGER ::  numdust                !: logical unit for surface fluxes data
+   INTEGER ::  nflx1 , nflx2          !: first and second record used
+   INTEGER ::  nflx11, nflx12
+
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: dustmo    !: set of dust fields
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: dust      !: dust fields
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: rivinp, cotdep    !: river input fields
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: nitdep    !: atmospheric N deposition 
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: ironsed   !: Coastal supply of iron
+
    REAL(wp) :: sumdepsi, rivalkinput, rivpo4input, nitdepinput
 
@@ -76,4 +75,5 @@
 CONTAINS
 
+
    SUBROUTINE p4z_sed( kt, jnt )
       !!---------------------------------------------------------------------
@@ -86,4 +86,8 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zsidep => wrk_2d_1, zwork => wrk_2d_2, zwork1 => wrk_2d_3
+      USE wrk_nemo, ONLY: znitrpot => wrk_3d_2, zirondep => wrk_3d_3
+      !
       INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
       INTEGER  ::   ji, jj, jk, ikt
@@ -94,9 +98,10 @@
       REAL(wp) ::   zdenitot, znitrpottot, zlim, zfact
       REAL(wp) ::   zwsbio3, zwsbio4, zwscal
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zsidep
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zwork, zwork1
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   znitrpot, zirondep
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
+
+      IF( ( wrk_in_use(2, 1,2,3) ) .OR. ( wrk_in_use(3, 2,3) ) ) THEN
+         CALL ctl_stop('p4z_sed: requested workspace arrays unavailable')  ;  RETURN
+      END IF
 
       IF( jnt == 1  .AND.  ln_dustfer  )  CALL p4z_sbc( kt )
@@ -288,4 +293,7 @@
        ENDIF
 
+      IF( ( wrk_not_released(2, 1,2,3) ) .OR. ( wrk_not_released(3, 2,3) ) )   &
+        &         CALL ctl_stop('p4z_sed: failed to release workspace arrays')
+
    END SUBROUTINE p4z_sed
 
@@ -474,5 +482,4 @@
       ryyss1 = 1. / ryyss
       !                                    ! ocean surface cell
-      e1e2t(:,:) = e1t(:,:) * e2t(:,:)
 
       ! total atmospheric supply of Si
@@ -512,4 +519,16 @@
    END SUBROUTINE p4z_sed_init
 
+   INTEGER FUNCTION p4z_sed_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_sed_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( dustmo(jpi,jpj,jpmth), dust(jpi,jpj)       ,     &
+        &       rivinp(jpi,jpj)      , cotdep(jpi,jpj)     ,     &
+        &       nitdep(jpi,jpj)      , ironsed(jpi,jpj,jpk), STAT=p4z_sed_alloc )  
+
+      IF( p4z_sed_alloc /= 0 ) CALL ctl_warn('p4z_sed_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_sed_alloc
 #else
    !!======================================================================
